package tests;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */



class RunnableThread implements Runnable {

	Thread runner;
	public RunnableThread() {
	}

	public RunnableThread(String threadName) {
		runner = new Thread(this, threadName); // (1) Create a new thread.
		System.out.println(runner.getName() + " starting: "+this.toString());
		runner.start(); // (2) Start the thread.
                System.out.println(runner.getName() + " started: "+this.toString());
	}

	public void run() {
		//Display info about this particular thread
		System.out.println(Thread.currentThread()+" START " +this.toString());
                try {
			//delay for one second
			//Thread.currentThread().sleep(10000);
                    this.runner.sleep(10000);
		} catch (InterruptedException e) {
		}
                System.out.println(Thread.currentThread()+" END " +this.toString());
	}

        public void printSomething() {
            //System.out.println(Thread.currentThread()+" printSomething");
            System.out.println(this.toString());
        }
}

public class Threads {

	public static void main(String[] args) {
		Thread thread1 = new Thread(new RunnableThread(), "thread1");
		Thread thread2 = new Thread(new RunnableThread(), "thread2");
		RunnableThread thread3 = new RunnableThread("thread3");
                try {
			//delay for one second
			Thread.currentThread().sleep(1000);
		} catch (InterruptedException e) {
		}
                thread3.printSomething();
                thread3.printSomething();
		//Start the threads
		thread1.start();
		thread2.start();
                System.out.println("some nonsense from main()");
                thread3.printSomething();

		try {
			//delay for one second
			Thread.currentThread().sleep(1000);
		} catch (InterruptedException e) {
		}
                thread3.printSomething();
		//Display info about the main thread
		System.out.println(Thread.currentThread());
	}
}