package tests;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


import java.util.logging.Level;
import java.util.logging.Logger;

public class WaitNotifyAllExample {

    public static void main(String[] args) {

        long startTime, stopTime;
        startTime = System.currentTimeMillis();

        try {
            //Object o = new Object();
            //Boolean o = new Boolean(true);
            double[] o = new double[10];


            int limit = 0;// number of worker threads
            int pollEveryMs = 0;
            boolean printALot = !false;

            if (args.length == 0) {
                limit = 1;
                pollEveryMs = 250;
            } else if (args.length == 3) {
                limit = Integer.parseInt(args[0]);
                pollEveryMs = Integer.parseInt(args[1]);
                printALot = Boolean.parseBoolean(args[2]);
            }

            // synchronized keyword acquires lock on the object.
//            synchronized (o) {
                System.out.println(" active threads: " + Thread.activeCount());

                int overallIndex = 0;

                //the giant look to do everything in parallel...
                while (true) {
                    //if (overallIndex == o.length) break;

                    if (printALot) printDoubleArray(o);
                    if (printALot) System.out.println("threads running: " + Thread.activeCount());

                    //1. may I start new threads?
                    if (Thread.activeCount() < 1 + limit) {

                        //2. now start new threads
                        //2.1. what is left?
                        for (int i = overallIndex; i < o.length; i++) {
                            
                            //if something had not yet been computed...
                            if (o[i] == 0d) {
                                //...start thread
                                Thread temp = new Thread(new MyOwnRunnable("foo", o, i));
                                temp.start();

                                //Thread.sleep(1000);

                                if (printALot) {
                                    Thread[] ta = new Thread[Thread.activeCount()];
                                    Thread.enumerate(ta);
                                    System.out.print("> ids: ");
                                    for (int t = 0; t<ta.length; t++) {
                                        if (ta[t]!=null)
                                            System.out.print(ta[t].getName()+" ");
                                    } System.out.println();
                                }

                                if (printALot) System.out.println("starting thread... total:" + Thread.activeCount()+" last started on i="+i);
                                overallIndex++;
                            }
                            // enough threads running? --> break
                            if (Thread.activeCount() >= 1 + limit) {
                                break;
                            }
                        }
                    }

                    //wait because the threads now have to work...
                    if (printALot) System.out.println("------------------------------ waiting");
                    //Thread.sleep(100);
                    //synchronized (o) {o.wait();}
                    Thread.sleep(pollEveryMs);
                    

                    //2.2 if nothing is left: break main loop
                    boolean somethingLeft = false;
                    for (int i = 0; i < o.length; i++) {
                        if (o[i] == 0d) {
                            somethingLeft = true;
                            if (printALot) System.out.println("something is left");
                            break;
                        }
                    }
                    if (!somethingLeft) {
                        if (printALot) System.out.println("nothing is left");
                        break;
                    }
                    if (printALot) System.out.println();
//                }

                if (printALot) System.out.println("------------------------------ waiting STOPPED");

                if (printALot) System.out.println(" active threads: " + Thread.activeCount());

//        System.out.println(">>start waiting");
//        Thread.sleep(5000);
//        System.out.println(">>waiting ended");


//                    stopTime = System.currentTimeMillis();
//                    System.out.println("---> time needed: " + (stopTime - startTime) / 1000d);

                }//END main loop

                
                stopTime = System.currentTimeMillis();
                System.out.println("---> time needed: " + (stopTime - startTime) / 1000d);

                System.out.println("all threads done");

                printDoubleArray(o);
                System.out.println(" number of worker threads: "+limit);
            

        } catch (InterruptedException e) {
            e.printStackTrace();
        }

    }

    public static void printDoubleArray(double[] da) {
        String result = "[";
        for (int i = 0; i < da.length - 1; i++) {
            result += da[i] + ",";
        }
        result += da[da.length - 1] + "]";
        System.out.println(result);
    }
}

class MyOwnRunnable implements Runnable {

    private String threadName;
    //private Boolean o;
    private double[] o;
    private int index = 0;

    //public MyOwnRunnable(String name, Object o) {
    //public MyOwnRunnable(String name, Boolean o) {
    public MyOwnRunnable(String name, double[] o, int index) {
        threadName = name;
        this.o = o;
        this.index = index;
    }

    public void run() {


//do heavy computation START
        String foo = "";
        double bar = 0;
        for (int i = 0; i < 20000; i++) {
            //System.out.println("Thread " + threadName + " Count : " + i);
            //try {Thread.sleep(100);} catch (Exception ex) {}
            foo = new String(foo + i);
            //bar += Math.random()*0.1*i*Math.pow(i, bar);
            bar +=i;
            if (foo.equals("foobar")) {
                System.out.println("never");
            }
            //if (bar == Math.pow(i,i)) {
            if (bar == Math.random()) {
                System.out.println("never");
            }

        }
        try {
            if (!true) Thread.sleep((long) (Math.random() * 1000));
            //System.out.println(foo);
            //do heavy computation END
        } catch (InterruptedException ex) {
            Logger.getLogger(MyOwnRunnable.class.getName()).log(Level.SEVERE, null, ex);
        }
        //System.out.println(foo);
//do heavy computation END


//        synchronized (o) {
//      if (this.threadName.equals("C")) {
//          o[0] = 1;
//      }
            o[index] = Math.random();

            // notify all threads waiting for the object o.
            // thread should acquire the lock on the object
            // before calling notify or notifyAll method on it.
            // Otherwise it will throw java.lang.IllegalMonitorStateException
//      try {

//            o.notifyAll();

            //} catch (Exception e) {}
//        }
    }
}
