package windCode;

import java.io.Serializable;

/**
 *
 * @author mwagner
 */
abstract public class Area implements Serializable{
    public int numberOfTurbines = 0;
    public boolean printSeveralOutputs = false;
    abstract public double[] startingSolution();
    abstract public boolean isFeasible(double[] coords);
    abstract public String toString();
    abstract public double computeInitialStandardDeviation();
    abstract public double[] fixSolution(double[] coords);
}


