package windCode.backups;

import java.util.Arrays;

/**
 *
 * @author wagner
 */
public class FarmLayout implements java.io.Serializable{
    
//    private Area area;
    public double[] coordinates;
    public double[] energyPerTurbine;
    public double totalEnergy;
    public boolean[] turbineMoved;
    
    // store for each wind direction theta a table of velocity deficits 
    double[][][] thetaVeldefijMatrix;
    // store for each wind direction theta
    double[][] thetaVeldefiVector;
    
    public FarmLayout(double[] coordinates) {
//    public FarmLayout(Area area, double[] coordinates) {
//        this.area = area;
        this.coordinates = coordinates;
        this.energyPerTurbine = new double[coordinates.length/2];
        this.totalEnergy = 0;
        
        this.turbineMoved = new boolean[coordinates.length/2];
        for (int i = 0; i<this.turbineMoved.length; i++) {
            this.turbineMoved[i] = false;
        }
        
        
        this.thetaVeldefijMatrix = new double[24][coordinates.length/2][coordinates.length/2];
        this.thetaVeldefiVector = new double[24][coordinates.length/2];
    }
    
//    public void printTurbineMoved() {
//        System.out.println(Arrays.toString(turbineMoved));
//    }
    
//    public void setEnergyPerTurbine(double[] energyPerTurbine) {
//        this.energyPerTurbine = energyPerTurbine;
//    }
    
//    public void setCoordinates(double[] coordinates) {
////        this.coordinates = coordinates;
//        for (int i = 0; i<this.turbineMoved.length; i++) {
//            if (this.coordinates[2*i]==coordinates[2*i]) {
//                // do nothing
//            } else {
//                this.coordinates[2*i] = coordinates[2*i];
//                this.turbineMoved[i] = true;
//            }
//            if (this.coordinates[2*i+1]==coordinates[2*i+1]) {
//                // do nothing
//            } else {
//                this.coordinates[2*i+1] = coordinates[2*i+1];
//                this.turbineMoved[i] = true;
//            }
//        }
//    }
    
    
//    public double computeTotalEnergy() {
//        double temp = 0;
//        
//        // check whether a turbine was relocated, if so: get energy for this turbine, and update the others!
//        for (int i = 0; i<this.turbineMoved.length; i++) {
//            if (this.turbineMoved[i]) {
//                // get energy for this turbine
//                
////TODO
//                // update the energy for the other turbines
////TODO
//            }
//        }
//        
//        // reset all fields in this.turbineMoved
//        for (int i = 0; i<this.turbineMoved.length; i++) {
//            this.turbineMoved[i] = false;
//        }
//        
//        // add all the energies up
//        for (double d:energyPerTurbine) {
//            temp += d;
//        }
//        
//        // return sum
//        this.totalEnergy = temp;
//        return this.totalEnergy;
//    }
    
    public void updateLocation(int turbine, double x, double y) {
        this.coordinates[turbine*2] = x;
        this.coordinates[turbine*2+1] = y;
        this.turbineMoved[turbine] = true;
    }
}
