package windCode.backups;

//package ownCode;
//
//import cma.CMASolution;
//import java.text.DecimalFormat;
//
///**
// *
// * @author mwagner
// */
//
////class WakeModel implements IObjectiveFunction{
//public class WakeModel implements java.io.Serializable{
//    public String wakeModel = "";
//    //parameters and scenario from "Kusiak 2010 Design of wind farm layout for maximum wind energy capture"
//
//    public static double R = 38.5; // rotor radius
//
//    public double cutInSpeed = 3.5;
//    public double ratedSpeed = 14;
//    public double[] windSpeeds = {cutInSpeed, 4.0, 4.5, 5.0, 5.5, 6.0, 6.5, 7.0, 7.5, 8.0, 8.5, 9.0,
//                                       9.5, 10.0, 10.5, 11.0, 11.5, 12.0, 12.5, 13.0, 13.5, ratedSpeed}; // v_0 = v_cutin, v_last = v_ratedSpeed
//
//    public double ratedPower = 1500; // in kilowatts
//
//    // wind distribution
//    public double[] windks = new double[0];
//    public double[] windcs = new double[0];
//    public double[] windthetas = {      15,  30,  45,  60,  75,  90, 105, 120, 135, 150, 165, 180,
//                                       195, 210, 225, 240, 255, 270, 285, 300, 315, 330, 345, 360};
//    public double[] windthetasMinusOne = {0,  15,  30,  45,  60,  75,  90, 105, 120, 135, 150, 165, 180,
//                                             195, 210, 225, 240, 255, 270, 285, 300, 315, 330, 345};
//    //public double windSectorSize = 15; // most likely not needed?
//    public double[] windSectorOmegasMinusOne = new double[0];
//
//    // for linear power curve function
//    public double lambda = 140.86;
//    public double eta = -500;
//
//    //public double hubHeight = 80;
//    public double CT = 0.8; // thrust coefficient
//    public double kappa = 0.075; // spreading konstant for land cases
//
//    //public double farmRadius = 0; // wind farm radius, will be set in the scenario
//    Area areal;
//
//    WakeModel(int scenario, String wakeModel) {
//
//        if (scenario==1){
//            double[] windks1 = {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
//                            2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2};
//            this.windks = windks1;
//            double[] windcs1 =  {13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
//                13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13}; // wind Weibull scale parameter (is the same in this scenario for all wind directions)
//            this.windcs = windcs1;
//            double[] windSectorOmegasMinusOne1 = {0,    0.01, 0.01, 0.01, 0.01, 0.2,  0.6,  0.01, 0.01, 0.01, 0.01, 0.01,
//                                                  0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0};
//            this.windSectorOmegasMinusOne = windSectorOmegasMinusOne1;
//
//        } else if (scenario==2){
//            double[] windks2 = {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
//                            2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2};
//            this.windks = windks2;
//            double[] windcs2 =  {7, 5, 5, 5, 5, 4, 5, 6, 7, 7, 8, 9.5,
//                10, 8.5, 8.5, 6.5, 4.6, 2.6, 8, 5, 6.4, 5.2, 4.5, 3.9};
//            this.windcs = windcs2;
//            double[] windSectorOmegasMinusOne2 = {0.0002, 0.008, 0.0227, 0.0242, 0.0225, 0.0339,  0.0423,  0.029, 0.0617, 0.0813, 0.0994, 0.1394,
//                                                  0.1839, 0.1115, 0.0765, 0.008, 0.0051, 0.0019, 0.0012, 0.001, 0.0017, 0.0031, 0.0097, 0.0317};
//            this.windSectorOmegasMinusOne = windSectorOmegasMinusOne2;
//
//        } else if (scenario==3){
//            double[] windks3 = {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
//                            2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2};
//            this.windks = windks3;
//            double[] windcs3 =  {5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
//                5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5};
//            this.windcs = windcs3;
//            double[] windSectorOmegasMinusOne3 = {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0,
//                                                  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
//            this.windSectorOmegasMinusOne = windSectorOmegasMinusOne3;
//
//        }
//
//        this.wakeModel = wakeModel;
//    }
//
//
//
//    // get energy per turbine (very similar to valueOf/2!
//    public double[] energyPerTurbine(double[] coords, boolean printEvaluationTimes) {
//
//        double[] result = new double[coords.length/2];
//
//        long startTime, stopTime;
//        startTime = System.currentTimeMillis();
//
//        // split coords s.t. x[] and y[]
//        int numberOfTurbines = coords.length/2;
//        double[] x = new double[numberOfTurbines];
//        double[] y = new double[numberOfTurbines];
//        for (int i=0; i<numberOfTurbines; i++) {
//            x[i] = coords[i*2];
//            y[i] = coords[i*2+1];
//        }
//
////        double result = 0;
//        for (int i=0; i<numberOfTurbines; i++) {
//
//            double temp = 0;
//
//            if (this.wakeModel.compareTo("o")==0) {
//                temp = energyOfTurbineOPTIMAL(x, y, i);
//            } else if (this.wakeModel.compareTo("w")==0) {
//                temp = energyOfTurbineWAKELOSS(x, y, i);
//            }
//
//            result[i] = temp;
//        }
//
//        stopTime = System.currentTimeMillis();
//        if (printEvaluationTimes) System.out.println("[time needed 'valueOf()':"+(stopTime-startTime)/1000.0+"s]");
//
//        return result;
//    }
//
//
//
//    // the fitness function
//    public double valueOf(double[] coords, boolean printEvaluationTimes) {
//
////        boolean isFeasible = true;
////        // split coords s.t. x[] and y[]
////        //int numberOfTurbines = coords.length/2;
////        int numberOfTurbines = coords.length/2;
////        double[] x = new double[numberOfTurbines];
////        double[] y = new double[numberOfTurbines];
////        for (int i=0; i<numberOfTurbines; i++) {
////            x[i] = coords[i*2];
////            y[i] = coords[i*2+1];
////        }
////
////        // constraint 1: be within area of windFarm
////        for (int i = 0; i < x.length; i++) {
////            if (x[i]>=10000 || x[i]<=0) isFeasible = false; //infeasible
////            if (y[i]>=20000 || y[i]<=0) isFeasible = false; //infeasible
////        }
////
////        // constraint 2: turbines placements should adhere to safety distances: 4 rotor diameters
////        for (int i = 0; i < x.length; i++) {
////            for (int j = 0; j < x.length; j++) {
////                if (i!=j) {
////                    if ( Math.sqrt( Math.pow(x[i]-x[j], 2) + Math.pow(y[i]-y[j], 2) ) < 4*(2*WakeModel.R))
////                        isFeasible = false; //infeasible
////                }
////            }
////        }
//
//
//        long startTime, stopTime;
//        startTime = System.currentTimeMillis();
//
//        // split coords s.t. x[] and y[]
//        int numberOfTurbines = coords.length/2;
//        double[] x = new double[numberOfTurbines];
//        double[] y = new double[numberOfTurbines];
//        for (int i=0; i<numberOfTurbines; i++) {
//            x[i] = coords[i*2];
//            y[i] = coords[i*2+1];
//        }
//
//        double result = 0;
//        for (int i=0; i<numberOfTurbines; i++) {
//
//            double temp = 0;
//
//            if (this.wakeModel.compareTo("o")==0) {
//                temp = energyOfTurbineOPTIMAL(x, y, i);
//            } else if (this.wakeModel.compareTo("w")==0) {
//                temp = energyOfTurbineWAKELOSS(x, y, i);
//            }
//
//            result += temp;
//        }
//
//        stopTime = System.currentTimeMillis();
//        if (printEvaluationTimes) System.out.println("[time needed 'valueOf()':"+(stopTime-startTime)/1000.0+"s]");
//
//// mediocre idea to penalize infeasible solutions. "mediocre" because of the (,)-strategy all generated solutions may be infeasible
////        if (isFeasible == false) {
////            result = result/2d;
////            System.out.println("i");
////        }
//
//        return 1.0/result;
//    }
//
//    public double computeWakelossFreeFitness(double[] coords) {
//        // split coords s.t. x[] and y[]
//        int numberOfTurbines = coords.length/2;
//        double[] x = new double[numberOfTurbines];
//        double[] y = new double[numberOfTurbines];
//        for (int i=0; i<numberOfTurbines; i++) {
//            x[i] = coords[i*2];
//            y[i] = coords[i*2+1];
//        }
//        double result = 0;
//        for (int i=0; i<numberOfTurbines; i++) {
//            double temp = 0;
//            temp = energyOfTurbineOPTIMAL(x, y, i);
//            result += temp;
//        }
//        return 1.0/result;
//    }
//
//    // formula 22 OPTIMAL, WITHOUT WAKELOSS
//    public double energyOfTurbineOPTIMAL(double[] x, double[] y, int i) {
//
//        double result = 0;
//
//        double temp = 0;
//
//        double firstSummand = 0;
//        double secondSummand = 0;
//        double thirdSummand = 0;
//
//        //FIRST
//        temp = 0;
//        for (int j = 1; j<this.windSpeeds.length; j++) {
//            double avgSpeed = (this.windSpeeds[j-1] + this.windSpeeds[j]) / 2.0;
//            double temp1 = 0;
//            for (int l = 0; l < this.windthetas.length; l++) {
//                temp1 += (this.windthetas[l]-this.windthetasMinusOne[l]) *
//                        this.windSectorOmegasMinusOne[l] *
//                        (
//                        Math.pow(Math.E, -(
//                            Math.pow( this.windSpeeds[j-1]/c(thetaAvg(l)),
//                                      k(thetaAvg(l))) )) -
//                        Math.pow(Math.E, -(
//                            Math.pow( this.windSpeeds[j  ]/c(thetaAvg(l)),
//                                      k(thetaAvg(l))) ))
//                        );
//            }
//            temp += avgSpeed * temp1;
//        }
//
//        firstSummand = lambda * temp;
//        //FIRST
//
//        //SECOND
//        temp = 0;
//        for (int l = 0; l<this.windthetas.length; l++) {
//            temp += (this.windthetas[l]-this.windthetasMinusOne[l]) *
//                     this.windSectorOmegasMinusOne[l] *
//                     Math.pow(
//                         Math.E,
//                         - Math.pow( (this.ratedSpeed/c(thetaAvg(l))),
//                                     k(thetaAvg(l)))  );
//        }
//        secondSummand = this.ratedPower * temp;
//        //SECOND
//
//        //THIRD
//        temp = 0;
//
//        for (int l = 0; l<this.windthetas.length; l++) {
//            temp += (this.windthetas[l]-this.windthetasMinusOne[l]) *
//                    this.windSectorOmegasMinusOne[l] *
//                    (
//                        Math.pow(Math.E, -(
//                            Math.pow( this.cutInSpeed/c(thetaAvg(l)),
//                                      k(thetaAvg(l))) )) -
//                        Math.pow(Math.E, -(
//                            Math.pow( this.ratedSpeed/c(thetaAvg(l)),
//                                      k(thetaAvg(l))) ))
//                        )
//                    ;
//        }
//
//        thirdSummand = this.eta * temp;
//        //THIRD
//
//        result = firstSummand + secondSummand + thirdSummand;
//        //System.out.println(result +" "+firstSummand+ " "+secondSummand+ " "+thirdSummand);
//        return result;
//    }
//
//    // formula 18
//    public double energyOfTurbineWAKELOSS(double[] x, double[] y, int i) {
//
//        double result = 0;
//
//        double temp = 0;
//
//        double firstSummand = 0;
//        double secondSummand = 0;
//        double thirdSummand = 0;
//
//        //optimization to save computation time:
//        double[] tempCiThetaAvgL = new double[this.windthetas.length];
//        double[] tempKThetaAvgL = new double[this.windthetas.length];
//        for (int l = 0; l < this.windthetas.length; l++) {
//            tempCiThetaAvgL[l] = ci(thetaAvg(l), x, y, i);
//            tempKThetaAvgL[l] = k(thetaAvg(l));
//        }
//
//
//        //FIRST
//        temp = 0;
//        for (int j = 1; j<this.windSpeeds.length; j++) {
//            double avgSpeed = (this.windSpeeds[j-1] + this.windSpeeds[j]) / 2.0;
//            double temp1 = 0;
//            for (int l = 0; l < this.windthetas.length; l++) {
//                temp1 += (this.windthetas[l]-this.windthetasMinusOne[l]) *
//                        this.windSectorOmegasMinusOne[l] *
//                        (
//                        Math.pow(Math.E, -(
//                            Math.pow( this.windSpeeds[j-1]/tempCiThetaAvgL[l],
//                                      tempKThetaAvgL[l]) )) -
//                        Math.pow(Math.E, -(
//                            Math.pow( this.windSpeeds[j  ]/tempCiThetaAvgL[l],
//                                      tempKThetaAvgL[l]) ))
//                        );
//            }
//            temp += avgSpeed * temp1;
//        }
//
//        firstSummand = lambda * temp;
//        //FIRST
//
//        //SECOND
//        temp = 0;
//        for (int l = 0; l<this.windthetas.length; l++) {
//            temp += (this.windthetas[l]-this.windthetasMinusOne[l]) *
//                     this.windSectorOmegasMinusOne[l] *
//                     Math.pow(
//                         Math.E,
//                         - Math.pow( this.ratedSpeed/tempCiThetaAvgL[l],
//                                     tempKThetaAvgL[l])  );
//        }
//        secondSummand = this.ratedPower * temp;
//        //SECOND
//
//        //THIRD
//        temp = 0;
//
//        for (int l = 0; l<this.windthetas.length; l++) {
//            temp += (this.windthetas[l]-this.windthetasMinusOne[l]) *
//                    this.windSectorOmegasMinusOne[l] *
//                    (
//                        Math.pow(Math.E, -(
//                            Math.pow( this.cutInSpeed/tempCiThetaAvgL[l],
//                                      tempKThetaAvgL[l]) )) -
//                        Math.pow(Math.E, -(
//                            Math.pow( this.ratedSpeed/tempCiThetaAvgL[l],
//                                      tempKThetaAvgL[l]) ))
//                        )
//                    ;
//        }
//
//        thirdSummand = this.eta * temp;
//        //THIRD
//
//        //System.out.println(firstSummand+ " "+secondSummand+ " "+thirdSummand);
//        result = firstSummand + secondSummand + thirdSummand;
//        return result;
//    }
//
//    // helper function to compute (theta_l+theta_l-1)/2
//    public double thetaAvg(int l) {
//        double result = 0;
//        result = (this.windthetas[l] + this.windthetasMinusOne[l]) / 2.0;
//        return result;
//    }
//
//    // formula 15
//    public double ci(double theta, double[] x, double[] y, int i) {
//        double result = 0;
//
//        result = c(theta) * (1.0 - Vel_def(x, y, i, theta));
//
//        return result;
//    }
//
//    // formula 14
//    public double Vel_def(double[] x, double[] y, int i, double theta) {
//
//        double result = 0;
//
//        for (int j = 0; j<x.length; j++) {
//            if (j!=i) {
//                double betaIJ = betaIJ(x, y, i, j, theta);
//                double alpha = Math.abs( Math.atan(this.kappa) );
//                if (betaIJ < alpha) {
//                    result += Vel_def(x, y, i, j, theta) * Vel_def(x, y, i, j, theta);
//                }
//            }
//        }
//
//        result = Math.sqrt(result);
//        return result;
//    }
//
//    // formula 9
//    public double betaIJ(double[] x, double[] y, int i, int j, double theta) {
//        double result = 0;
//        result = Math.acos(
//                ( (x[i]-x[j])*Math.cos(theta) + (y[i]-y[j])*Math.sin(theta) + R/this.kappa )
//                /
//                (Math.sqrt(  Math.pow( (x[i]-x[j]+R/this.kappa*Math.cos(theta)), 2) +
//                             Math.pow( (y[i]-y[j]+R/this.kappa*Math.sin(theta)), 2))
//                 ));
//        return result;
//    }
//
//    // formula 7
//    public double Vel_def(double[] x, double[] y, int i, int j, double theta) {
//        double result = 0;
//
//        double a = 1 - Math.sqrt(1-this.CT);
//        double b = this.kappa / R;
//
//        result = a / Math.pow(1 + b * d(x, y, i, j, theta), 2);
//
//        return result;
//    }
//
//    // formula 13
//    public double d(double[] x, double[] y, int i, int j, double theta) {
//        double result = 0;
//
//        //result = Math.abs( (x[i*2]-x[j*2]) * Math.cos(theta) + (x[i*2+1]*x[j*2+1])*Math.sin(theta) );
//        result = Math.abs( (x[i]-x[j])*Math.cos(theta) + (y[i]-y[j])*Math.sin(theta) );
//        return result;
//    }
//
//    // returns the wind Weibull scale parameter - dependend on theta
//    public double c(double theta) {
//        double result = 0;
//        int index = -1;
//        //lookup the index in the windthetas-table, and then return the corresponding windc
//        for (int i = 0; i<this.windthetas.length; i++) {
//            if (Math.abs( this.windthetas[i] - theta) <0.01 ) {
//                System.out.println("function c(theta)!");
//                index = i;
//                break;
//            }
//        }
//
//        if (index != -1) {
//            // right theta + corresponding index were found
//            result = this.windcs[index];
//        } else {
//            // take avg of two neighboring windthetas resp neighboring windcs
//            for (int i = 0; i<this.windthetas.length; i++) {
//                // when "windthetas[i]>theta" then the right intermediate index was found
//                if (windthetas[i]>theta) {
//                    int j = i-1;
//                    if (j==-1) j = windcs.length-1;
//
//                    // the following two lines make important performance differences!!!!!!!!!!!!!!!!!!
//                    // "ideal" means: ideal according to Kusiak 2010 --> Kusiak's implementation/formula is buggy.
//                    /* 1nd scenario
//                     *  2 turbines -> ideal 28091.47, 1st line 28091.47, 2nd line 28091.47
//                     *  3 turbines -> ideal 42137.21, 1st line 42137.21, 2nd line 42137.21
//                     *  4 turbines -> ideal 56182.95, 1st line 56182.95, 2nd line 56182.95
//                     *  5 turbines -> ideal 70228.69, 1st line 70228.69, 2nd line 70228.69
//                     *  6 turbines -> ideal 84274.42, 1st line 84274.42, 2nd line 84274.42
//                     *  --> no surprise that my numbers match, as 'c' is constant in this scenario
//                     *      however, this is a good test of my implementation
//                     */
//                    /* 2nd scenario
//                     *  2 turbines -> ideal 14631.37, 1st line 14226.72, 2nd line 14630.76  (one solution: 14630.60)
//                     *  3 turbines -> ideal 21947.06, 1st line 21340.07, 2nd line 21946.14  (one solution: 21942.75)
//                     *  4 turbines -> ideal 29262.74, 1st line 28453.43, 2nd line 29261.51  (one solution: 29252.87)
//                     *  5 turbines -> ideal 36578.43, 1st line 35566.79, 2nd line 36576.89  (one solution: 36420.13)
//                     *  6 turbines -> ideal 43894.11, 1st line 42680.15, 2nd line 43892.27  (one solution: 43729.67)
//                     *  --> tiny deviations, maybe due to rounding errors in scenario table
//                     *  --> rougly 0.5-1.5% improvement over Kusiak 2010
//                     * furthermore: number of possible turbines: 7, ... (just checked whether feasible solutions found)
//                     *              (confirmed via drawing: 9 turbines are possible to place using a "squared grid")
//                     */
//                    //result = (windcs[i] + windcs[j]) / 2.0; //that would be correct according to the official formula: the avg of two neighboring sectors.
//                    result = windcs[i];
//
//                    break;
//                }
//            }
//        }
//
//        //if (true) System.out.println("theta:"+theta+" c(theta):"+result);
//
//        return result;
//    }
//
//    // returns the wind Weibull shape parameter - dependend on theta (CURRENTLY NOT DEPENDEND)
//    public double k(double theta) {
////        double result = 0;
////        int index = 0;
////        //lookup the index in the windthetas-table, and then return the corresponding windk
////        for (int i = 0; i<this.windthetas.length; i++) {
////            if (Math.abs( this.windthetas[i] - theta) <0.01 ) {
////                index = i;
////                break;
////            }
////        }
////        result = this.windks[index];
////        return result;
//        return 2;
//    }
//
//    // function that checks whether a current solution is feasible, dependent on the area
//    public boolean isFeasible(double[] coords, Area areal) {
//        return areal.isFeasible(coords);
//    }
//
//        // helper function to nicely print a solution
//    public static void printSolution(CMASolution cs, double[] energyPerTurbine) {
//        double[] coords = cs.getX();
//
//        // split coords s.t. x[] and y[]
//        int numberOfTurbines = coords.length/2;
//        double[] x = new double[numberOfTurbines];
//        double[] y = new double[numberOfTurbines];
//        for (int i=0; i<numberOfTurbines; i++) {
//            x[i] = coords[i*2];
//            y[i] = coords[i*2+1];
//        }
//
//        String s = "values: x, y, energyPerTurbine\n";
//        for (int i = 0; i<x.length; i++) {
//            s += (x[i]) + " " +(y[i]) + " " + energyPerTurbine[i];
//            s += "\n";
//        }
//        System.out.println(s);
//    }
//
//    public static void printSolution(double[] c, double[] energyPerTurbine) {
//        double[] coords = c;
//
//        // split coords s.t. x[] and y[]
//        int numberOfTurbines = coords.length/2;
//        double[] x = new double[numberOfTurbines];
//        double[] y = new double[numberOfTurbines];
//        for (int i=0; i<numberOfTurbines; i++) {
//            x[i] = coords[i*2];
//            y[i] = coords[i*2+1];
//        }
//
//        String s = "values: x, y, energyPerTurbine\n";
//        for (int i = 0; i<x.length; i++) {
//            s += (x[i]) + " " +(y[i]) + " " + energyPerTurbine[i];
//            s += "\n";
//        }
//        System.out.println(s);
//    }
//
//
//    // helper function to nicely print a solution
//    public static void printSolution(CMASolution cs) {
//        double[] coords = cs.getX();
//
//        // split coords s.t. x[] and y[]
//        int numberOfTurbines = coords.length/2;
//        double[] x = new double[numberOfTurbines];
//        double[] y = new double[numberOfTurbines];
//        for (int i=0; i<numberOfTurbines; i++) {
//            x[i] = coords[i*2];
//            y[i] = coords[i*2+1];
//        }
//
////        DecimalFormat df = new DecimalFormat(" 000.000");
////        DecimalFormat dfneg = new DecimalFormat("000.000");
//        String s = "";
//        for (int i = 0; i<x.length-1; i++) {
////            s += "  "+(x[i]>0?df.format(x[i]):dfneg.format(x[i]))
////               + " " +(y[i]>0?df.format(y[i]):dfneg.format(y[i]));
//            s += ""+x[i]
//               + " " +y[i];
////            s += "  (distFromOrigin:"+Math.sqrt(x[i]*x[i] + y[i]*y[i])+")";
//            s += "\n";
//        }
////        s += "  "+(x[x.length-1]>0?df.format(x[x.length-1]):dfneg.format(x[x.length-1]))
////           + " " +(y[y.length-1]>0?df.format(y[y.length-1]):dfneg.format(y[y.length-1]));
//        s += ""+(x[x.length-1])
//           + " " +(y[y.length-1]);
////        s += "  (distFromOrigin:"+Math.sqrt(x[x.length-1]*x[x.length-1] + y[y.length-1]*y[y.length-1])+")";
//        System.out.println(s);
//    }
//
//
//    // helper function to nicely print a solution
//    public static void printSolution(double[] c) {
//        double[] coords = c;
//
//        // split coords s.t. x[] and y[]
//        int numberOfTurbines = coords.length/2;
//        double[] x = new double[numberOfTurbines];
//        double[] y = new double[numberOfTurbines];
//        for (int i=0; i<numberOfTurbines; i++) {
//            x[i] = coords[i*2];
//            y[i] = coords[i*2+1];
//        }
//
////        DecimalFormat df = new DecimalFormat(" 000.000");
////        DecimalFormat dfneg = new DecimalFormat("000.000");
//        String s = "";
//        for (int i = 0; i<x.length-1; i++) {
////            s += "  "+(x[i]>0?df.format(x[i]):dfneg.format(x[i]))
////               + " " +(y[i]>0?df.format(y[i]):dfneg.format(y[i]));
//            s += ""+(x[i])
//               + " " +(y[i]);
////            s += "  (distFromOrigin:"+Math.sqrt(x[i]*x[i] + y[i]*y[i])+")";
//            s += "\n";
//        }
////        s += "  "+(x[x.length-1]>0?df.format(x[x.length-1]):dfneg.format(x[x.length-1]))
////           + " " +(y[y.length-1]>0?df.format(y[y.length-1]):dfneg.format(y[y.length-1]));
//        s += ""+(x[x.length-1])
//           + " " +(y[y.length-1]);
////        s += "  (distFromOrigin:"+Math.sqrt(x[x.length-1]*x[x.length-1] + y[y.length-1]*y[y.length-1])+")";
//        System.out.println(s);
//    }
//
//
//
//    public static void main(String[] args) {
//        // the fitness function
////    public double valueOf(double[] coords, boolean printEvaluationTimes) {
//        boolean printEvaluationTimes = true;
//    double[] coords = { 1000, 2000, 3000, 4000};
//
//        long startTime, stopTime;
//        startTime = System.currentTimeMillis();
//
//        // split coords s.t. x[] and y[]
//        int numberOfTurbines = coords.length/2;
//        double[] x = new double[numberOfTurbines];
//        double[] y = new double[numberOfTurbines];
//        for (int i=0; i<numberOfTurbines; i++) {
//            x[i] = coords[i*2];
//            y[i] = coords[i*2+1];
//        }
//
//        double result = 0;
//        for (int i=0; i<numberOfTurbines; i++) {
//
//            double temp = 0;
//
////            if (this.wakeModel.compareTo("o")==0) {
////                temp = energyOfTurbineOPTIMAL(x, y, i);
////            } else if (this.wakeModel.compareTo("w")==0) {
//                temp = energyOfTurbineWAKELOSS(x, y, i);
////            }
//
//            result += temp;
//        }
//
//        stopTime = System.currentTimeMillis();
//        if (printEvaluationTimes) System.out.println("[time needed 'valueOf()':"+(stopTime-startTime)/1000.0+"s]");
//
//// mediocre idea to penalize infeasible solutions. "mediocre" because of the (,)-strategy all generated solutions may be infeasible
////        if (isFeasible == false) {
////            result = result/2d;
////            System.out.println("i");
////        }
//
//        return 1.0/result;
//    }
//
//
//
//    }
//}