package directSpread.utility;

public interface Problem {

	public void evaluate(Solution newSolution);

	public Variable[] createVariables();

	public double[] getInitialDistanceMus();

	public double[] getInitialDistanceSigmas();

	public double[] getInitialDirectionSigmas();

	public double getDistanceMuIncrease();

	public double getDistanceSigmaIncrease();

	public double getDistanceMuDecrease();

	public double getDistanceSigmaDecrease();

	public double getDistanceSigmaMax();

	public double getDistanceSigmaMin();

	public double getDistanceMuMax();

	public double getDistanceMuMin();

}
